Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 199856 - build plan does not properly account for missing dependencies of installed packages
Summary: build plan does not properly account for missing dependencies of installed pa...
Status: CONFIRMED
Alias: None
Product: Portage Development
Classification: Unclassified
Component: Core - Dependencies (show other bugs)
Hardware: All Linux
: High normal (vote)
Assignee: Portage team
URL:
Whiteboard:
Keywords:
: 200646 222207 231928 253519 261744 290721 291366 293112 645958 (view as bug list)
Depends on:
Blocks: 155723 build-order
  Show dependency tree
 
Reported: 2007-11-21 02:20 UTC by Robin Johnson
Modified: 2019-12-26 23:01 UTC (History)
17 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Robin Johnson archtester Gentoo Infrastructure gentoo-dev Security 2007-11-21 02:20:53 UTC
Ok, so I'm upgrading from 3.5.7 to 3.5.8, and I hit this failure, looks like the dependancies of kdebase are wrong.

# emerge -uDpv kde

These are the packages that would be merged, in order:

Calculating dependencies... done!
[ebuild     U ] kde-base/kdebase-3.5.8-r1 [3.5.7] USE="cups hal java ldap logitech-mouse openexr opengl pam samba xcomposite xinerama xscreensaver -arts -branding% -debug -ieee1394 -kdeenablefinal -kdehiddenvisibility -lm_sensors" 0 kB 
[ebuild     U ] kde-base/kdemultimedia-3.5.8 [3.5.7] USE="alsa encode flac gstreamer mp3 theora vorbis xinerama -akode -arts -audiofile -debug -kdeenablefinal -xine" 0 kB 
[ebuild     U ] kde-base/kdepim-3.5.8 [3.5.7] USE="gnokii pda%* xinerama -arts -debug -kdeenablefinal (-crypt%*)" 0 kB 
[ebuild     U ] kde-base/kdegames-3.5.8 [3.5.7] USE="xinerama -arts -debug -kdeenablefinal -kdehiddenvisibility" 0 kB 
[ebuild  N    ] kde-misc/kdnssd-avahi-0.1.2  USE="xinerama -arts -debug" 0 kB 
[ebuild     U ] kde-base/kdenetwork-3.5.8 [3.5.7] USE="rdesktop slp ssl xinerama -arts -debug -jingle -kdeenablefinal -kdehiddenvisibility -sametime -wifi" 0 kB 
[ebuild     U ] kde-base/kdeartwork-3.5.8 [3.5.7] USE="opengl xinerama xscreensaver -arts -debug -kdeenablefinal" 0 kB 
[ebuild     U ] kde-base/kdeaddons-3.5.8 [3.5.7] USE="berkdb sdl xinerama -arts -debug -kdeenablefinal" 0 kB 
[ebuild     U ] kde-base/kdeedu-3.5.8 [3.5.7] USE="xinerama -arts -debug -kdeenablefinal -kig-scripting -solver%" 0 kB 
[ebuild     U ] kde-base/kdetoys-3.5.8 [3.5.7] USE="xinerama -arts -debug -kdeenablefinal -kdehiddenvisibility" 0 kB 
[ebuild     U ] kde-base/kdeutils-3.5.8 [3.5.7] USE="crypt snmp xinerama xscreensaver -arts -debug -kdeenablefinal -kdehiddenvisibility (-pbbuttonsd)" 0 kB 
[ebuild     U ] kde-base/kdewebdev-3.5.8 [3.5.7] USE="doc xinerama -arts -debug -kdeenablefinal -kdehiddenvisibility -tidy" 0 kB 
[ebuild     U ] kde-base/kdeadmin-3.5.8 [3.5.7] USE="xinerama -arts -debug -kdeenablefinal -kdehiddenvisibility" 0 kB 
[ebuild     U ] kde-base/kdegraphics-3.5.8-r1 [3.5.7] USE="imlib openexr opengl pdf scanner tetex xinerama -arts -debug -gphoto2 -kdeenablefinal -povray" 0 kB 
[ebuild     U ] kde-base/kde-3.5.8 [3.5.7] USE="-accessibility" 0 kB 

Total: 15 packages (14 upgrades, 1 new), Size of downloads: 0 kB

i686-pc-linux-gnu-g++ -DHAVE_CONFIG_H -I. -I. -I../.. -I./ksgrd -I./SensorDisplayLib -I../../ksysguard/gui/SensorDisplayLib -I/usr/kde/3.5/include -I/usr/qt/3/include -I.   -DQT_THREAD_SUPPORT  -D_REENTRANT -D_FILE_OFFSET_BITS=64 -D_LARGE_FILES=1  -Wno-long-long -Wundef -ansi -D_XOPEN_SOURCE=500 -D_BSD_SOURCE -Wcast-align -Wchar-subscripts -Wall -W -Wpointer-arith -DNDEBUG -DNO_DEBUG -O2 -march=athlon-xp -Os -pipe -Wformat-security -Wmissing-format-attribute -Wno-non-virtual-dtor -fno-exceptions -fno-check-new -fno-common -DQT_CLEAN_NAMESPACE -DQT_NO_ASCII_CAST -DQT_NO_STL -DQT_NO_COMPAT -DQT_NO_TRANSLATION -D_GNU_SOURCE  -c -o ksysguard_skel.o ksysguard_skel.cc
/bin/sh ../../libtool --silent --tag=CXX --mode=link i686-pc-linux-gnu-g++  -Wno-long-long -Wundef -ansi -D_XOPEN_SOURCE=500 -D_BSD_SOURCE -Wcast-align -Wchar-subscripts -Wall -W -Wpointer-arith -DNDEBUG -DNO_DEBUG -O2 -march=athlon-xp -Os -pipe -Wformat-security -Wmissing-format-attribute -Wno-non-virtual-dtor -fno-exceptions -fno-check-new -fno-common -DQT_CLEAN_NAMESPACE -DQT_NO_ASCII_CAST -DQT_NO_STL -DQT_NO_COMPAT -DQT_NO_TRANSLATION -D_GNU_SOURCE    -o ksysguard -L/usr/kde/3.5/lib -L/usr/qt/3/lib     -R /usr/kde/3.5/lib -R /usr/kde/3.5/lib -R /usr/qt/3/lib SensorBrowser.o WorkSheet.o WorkSheetSettings.o Workspace.o ksysguard.o ksysguard_skel.o ksgrd/libksgrd.la SensorDisplayLib/libsensordisplays.la -lkdeui -lkio -lkdnssd 
/usr/lib/gcc/i686-pc-linux-gnu/4.1.2/../../../../i686-pc-linux-gnu/bin/ld: cannot find -lkdnssd
collect2: ld returned 1 exit status
make[4]: *** [ksysguard] Error 1
make[4]: *** Waiting for unfinished jobs....
make[4]: Leaving directory `/var/tmp/portage/kde-base/kdebase-3.5.8-r1/work/kdebase-3.5.8/ksysguard/gui'
make[3]: *** [all-recursive] Error 1
make[3]: Leaving directory `/var/tmp/portage/kde-base/kdebase-3.5.8-r1/work/kdebase-3.5.8/ksysguard/gui'
make[2]: *** [all-recursive] Error 1
make[2]: Leaving directory `/var/tmp/portage/kde-base/kdebase-3.5.8-r1/work/kdebase-3.5.8/ksysguard'
make[1]: *** [all-recursive] Error 1
make[1]: Leaving directory `/var/tmp/portage/kde-base/kdebase-3.5.8-r1/work/kdebase-3.5.8'
make: *** [all] Error 2
 *
Comment 1 Robin Johnson archtester Gentoo Infrastructure gentoo-dev Security 2007-11-21 02:25:27 UTC
I confirm that merging kde-misc/kdnssd-avahi ahead of kdebase allows kdebase to compile, so please change the deps for kdebase?

Looking at the full deptree from when I first ran emerge -u kde, I see that the kdelibs has a PDEPEND on kdnssd-avahi, and it scheduled it way later than kdebase.
Comment 2 Jakub Moc (RETIRED) gentoo-dev 2007-11-21 09:50:08 UTC
Which portage version you have installed?
Comment 3 Robin Johnson archtester Gentoo Infrastructure gentoo-dev Security 2007-11-21 09:57:21 UTC
Portage 2.1.3.19 (default-linux/x86/2006.1/desktop, gcc-4.1.2, glibc-2.6.1-r0, 2.6.21-rc6-mm1 i686)
=================================================================
System uname: 2.6.21-rc6-mm1 i686 AMD Athlon(tm)
Timestamp of tree: Unknown
ccache version 2.4 [enabled]
app-shells/bash:     3.2_p17-r1
dev-java/java-config: 1.3.7, 2.1.2-r1
dev-lang/python:     2.3.6-r2, 2.4.4-r4, 2.5.1-r4
dev-python/pycrypto: 2.0.1-r6
dev-util/ccache:     2.4-r7
dev-util/confcache:  0.4.2-r1
sys-apps/baselayout: 1.12.10-r5
sys-apps/sandbox:    1.2.18.1-r2
sys-devel/autoconf:  2.13, 2.61-r1
sys-devel/automake:  1.4_p6, 1.5, 1.6.3, 1.7.9-r1, 1.8.5-r3, 1.9.6-r2, 1.10
sys-devel/binutils:  2.18-r1
sys-devel/gcc-config: 1.4.0-r4
sys-devel/libtool:   1.5.24
virtual/os-headers:  2.6.23-r2
ACCEPT_KEYWORDS="x86 ~x86"
CBUILD="i686-pc-linux-gnu"
CFLAGS="-march=athlon-xp -Os -pipe"
CHOST="i686-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/kde/3.5/env /usr/kde/3.5/share/config /usr/kde/3.5/shutdown /usr/share/config"
CONFIG_PROTECT_MASK="/etc/env.d /etc/env.d/java/ /etc/fonts/fonts.conf /etc/gconf /etc/revdep-rebuild /etc/terminfo /etc/texmf/web2c /etc/udev/rules.d"
CXXFLAGS="-march=athlon-xp -Os -pipe"
DISTDIR="/home/gentoo/distfiles"
FEATURES="assume-digests autoaddcvs buildpkg ccache collision-protect cvs digest distlocks lmirror metadata-transfer mirror parallel-fetch sandbox sfperms splitdebug strict unmerge-orphans userfetch userpriv"
GENTOO_MIRRORS="http://distfiles.gentoo.org http://distro.ibiblio.org/pub/linux/distributions/gentoo"
LANG="en_US.UTF-8"
LINGUAS="en en_CA en_US en_GB en_ZA"
MAKEOPTS="-j2"
PKGDIR="/home/gentoo/packages/newton-int"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --compress --force --whole-file --delete --delete-after --stats --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --filter=H_**/files/digest-*"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/code/gentoo/gentoo-cvs/gentoo-x86"
PORTDIR_OVERLAY="/usr/local/portage-layman/flameeyes-overlay-private /usr/local/portage"
SYNC="rsync://rsync.gentoo.org/gentoo-portage"
USE="3dnow 3dnowext X a52 aac aalib acl acpi aio alsa amd ao apm ares async automount avahi avi berkdb bitmap-fonts bluetooth browserplugin bzip2 cairo calendar caps cdb cdda cdr cgi clamav clearpasswd cli cpdflib cracklib crypt cscope ctype cups curl curlwrappers daap dbus device-mapper divx4linux dmx doc dri dts dv dvd dvdr dvdread dynagraph emboss encode ethereal exif expat f77 fam fame fastcgi ffmpeg fftw firefox flac flash foomaticdb fortran fpx frxp gcj gd gdbm geoip gif glitz glx gmp gnokii gnults gnuplot gnutls gpm graphviz gs gstreamer gzip hal hpn ical iconv imap imlib innodb insecure-savers ipalias ipod ipv6 irda isdnlog jack jack-tmpfs java javadoc jbig joystick jpeg jpeg2k lcms ldap libnotify libsamplerate libwww linuxthreads-tls live logitech-mouse lzo mad maildir mbox mcal md5sum midi mikmod mjpeg mmx mmxext mod motif mozilla mozplugin mp3 mpeg mpm-prefork mudflap multicall musicbrainz mysql ncurses netjack network nptl nptlonly nsplugin numeric nvidia objc offensive ogg oggvorbis openexr opengl openmp osd pam pcap pcre pda pdf pdflib perl pg-intdatetime pic plotutils png pnp portaudio ppds pppd pulseaudio python qmail quicktime quotas rdesktop readline reflection rtc ruby samba scanner screen sdl session shout skins slang slp sms sndfile snmp socks5 speex spell spl sqlite sse ssl stream svg swat syslog t1lib tcltk tetex theora tiff truetype truetype-fonts type1 type1-fonts ungif unicode usb userlocales utf8 v4l v4l2 vcd vhosts vidix vim-syntax vlm vorbis win32codecs winbind wmf wxwindows x86 xanim xcb xchatdccserver xcomposite xinerama xml xml2 xorg xosd xrandr xscreensaver xv xvid xvmc yv12 zeroconf zlib" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1 emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" ALSA_PCM_PLUGINS="adpcm alaw asym copy dmix dshare dsnoop empty extplug file hooks iec958 ioplug ladspa lfloat linear meter mulaw multi null plug rate route share shm softvol" ELIBC="glibc" FOO2ZJS_DEVICES="hp1020" INPUT_DEVICES="evdev keyboard mouse void" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LINGUAS="en en_CA en_US en_GB en_ZA" USERLAND="GNU" VIDEO_CARDS="dummy nv nvidia vga vesa none"
Unset:  CPPFLAGS, CTARGET, EMERGE_DEFAULT_OPTS, INSTALL_MASK, LC_ALL, LDFLAGS, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS

Comment 4 Jakub Moc (RETIRED) gentoo-dev 2007-11-21 10:04:16 UTC
This is a dupe of Bug 180045 (and if you read that one,  Comment #12, Comment #14 and others still stand, kde-misc/kdnssd-avahi shouldn't be a separate ebuild at all). No clue if this is a 2.1.3.19 regression, do you get better ordering w/ say 2.1.3.16 or some other version?
Comment 5 Robin Johnson archtester Gentoo Infrastructure gentoo-dev Security 2007-11-21 10:16:40 UTC
Ah, reading that one, and zmedico's code. I can see how it would still be triggerable.

1. emerge kdelibs, ctrl-c before PDEPENDS are installed.
2. emerge kde (my output below is the install order).

I'm pretty sure that kdebase should declare it's dependancy on kde-misc/kdnssd-avahi since it links against it.
Comment 6 Jakub Moc (RETIRED) gentoo-dev 2007-11-28 18:22:10 UTC
*** Bug 200646 has been marked as a duplicate of this bug. ***
Comment 7 Jeff Hayes 2007-12-22 18:34:03 UTC
Fresh install of gentoo-2007.0 amd64 with emerge kde-meta hit this dependency bug while building libkdegames-3.5.8 .

emerge kde-misc/kdnssd-avahi worked around, as suggested.
Comment 8 Carsten Lohrke (RETIRED) gentoo-dev 2007-12-23 01:10:47 UTC
(In reply to comment #5)
> I'm pretty sure that kdebase should declare it's dependancy on
> kde-misc/kdnssd-avahi since it links against it.

When you look at kdelibs, you see the dependency has to be there. The real problem is that runtime dependencies aren't always built beforehand, unless there is some cyclic depend/rdepend issue. This would mean, we'd get rid of PDEPEND entirely, btw..

Reassiging, as its a persisting Portage problem...

Comment 9 Zac Medico gentoo-dev 2007-12-23 02:58:42 UTC
(In reply to comment #8)
> When you look at kdelibs, you see the dependency has to be there. The real
> problem is that runtime dependencies aren't always built beforehand, unless
> there is some cyclic depend/rdepend issue.

You're right that the merge order isn't as optimal as it could be in this case. However, I suggest that you add an explicit dependency to kdebase as a workaround for this bug.
Comment 10 Carsten Lohrke (RETIRED) gentoo-dev 2007-12-23 15:42:10 UTC
(In reply to comment #9)
> However, I suggest that you add an explicit dependency to kdebase as a
> workaround for this bug.

It's a use dependency 

DEPEND"kde-base/kdelibs[avahi]? ( kde-misc/kdnssd-avahi)" 

or whatever the syntax would be and it isn't just kdebase that is affected.

Is actually anyone working on use dependencies atm.? It's in pratice the no.1 problem - I value it even higher than missing reverse dependency support.
Comment 11 Zac Medico gentoo-dev 2007-12-23 22:26:48 UTC
Yes, I am working on dependencies among other things (bug 155723 tracks dependency issues).  I'll get this bug fixed eventually. It's going to require some more advanced state tracking than what we have now, similar to what's needed for bug 172812. Basically, we need to consider packages that are installed but have missing dependencies as "unrunnable".
Comment 12 Neil Stone 2008-07-04 18:07:26 UTC
Same issue here guys...

Portage 2.1.4.4 (default/linux/amd64/2008.0, gcc-4.1.2, glibc-2.6.1-r0, 2.6.25-gentoo-r6 x86_64)
=================================================================
System uname: 2.6.25-gentoo-r6 x86_64 AMD Phenom(tm) 9850 Quad-Core Processor
Timestamp of tree: Fri, 04 Jul 2008 05:15:01 +0000
app-shells/bash:     3.2_p33
dev-java/java-config: 1.3.7, 2.1.6
dev-lang/python:     2.4.4-r13
dev-python/pycrypto: 2.0.1-r6
sys-apps/baselayout: 1.12.11.1
sys-apps/sandbox:    1.2.18.1-r2
sys-devel/autoconf:  2.13, 2.61-r2
sys-devel/automake:  1.5, 1.7.9-r1, 1.8.5-r3, 1.9.6-r2, 1.10.1
sys-devel/binutils:  2.18-r1
sys-devel/gcc-config: 1.4.0-r4
sys-devel/libtool:   1.5.26
virtual/os-headers:  2.6.23-r3
ACCEPT_KEYWORDS="amd64"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-march=k8 -O2 -pipe"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/kde/3.5/env /usr/kde/3.5/share/config /usr/kde/3.5/shutdown /usr/share/config"
CONFIG_PROTECT_MASK="/etc/env.d /etc/env.d/java/ /etc/fonts/fonts.conf /etc/gconf /etc/revdep-rebuild /etc/terminfo /etc/udev/rules.d"
CXXFLAGS="-march=k8 -O2 -pipe"
DISTDIR="/usr/portage/distfiles"
FEATURES="ccache collision-protect distlocks fixpackages metadata-transfer parallel-fetch sfperms strict unmerge-orphans userfetch"
GENTOO_MIRRORS="http://gentoo.virginmedia.com           ftp://mirrors.blueyonder.co.uk/mirrors/gentoo           http://www.mirrorservice.org/sites/www.ibiblio.org/gentoo/                 ftp://ftp.mirrorservice.org/sites/www.ibiblio.org/gentoo/"
LINGUAS="en en_GB"
MAKEOPTS="-j3"
PKGDIR="/usr/portage/packages"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --compress --force --whole-file --delete --stats --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/usr/portage"
SYNC="rsync://rsync.uk.gentoo.org/gentoo-portage"
USE="3dnow 3dnowext 7zip X Xaw3d a52 aac aalib acl acpi additions aim alsa amavis amd64 apache2 apm ares arts audiofile avahi avi bash-completion bidi blender-game bluetooth browser bzip2 bzlib calendar cdda cddb cdparanoia cdr cgi clamav cli corba cpudetection cracklib crypt css curl daap dbus dga divx4linux dri dts dv dvb dvd dvdr dvdread emacs emerald encode esd ethereal exif expat extras fax fbcon ffmpeg firefox flac flash font-server foomaticdb fortran ftp gcj gd gdbm ggi gif gimp gimpprint glitz gnutls gocr gpm gps gstreamer gtk gtk2 hal hddtemp httpd iconv icq iee1394 ieee1394 imagemagick isdnlog jabber java javascript joystick jpeg kde kdehiddenvisibility libcaca live lm_sensors logitech-mouse logrotate matroska mcve mdnsresponder-compat mgetty midi mikmod mime mmx mng mod mozilla mozsvg mp3 mpeg mplayer msn mudflap multilib musepack musicbrainz mysql nagios-dns nagios-game nagios-ntp nagios-ping nagios-ssh nas ncurses network network-cron nls nodrm nptl nptlonly nsplugin ntfs nvidia ocrad odk offensive ogg oggvorbis opengl openmp optimisememory osc oscar oss pam passwordsave pcre pda pdf pdflib perl php pic pkcs11 plotutils png postscript ppds pppd python qt3 qt4 quicktime rar rdesktop readline recode reflection rtsp samba sasl scanner sdl sensord session shout skins slang sndfile sound sox speex spell spl sse sse2 ssl stream subtitles svg symlink tcltk tcpd tesseract theora threads tidy tiff tk truetype unicode upnp ups usb utf8 v4l v4l2 vcd videos vlm vorbis wmf wxwindows xcomposite xine xinerama xml xorg xosd xpm xscreensaver xv xvid yahoo yv12 zeroconf zlib" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" ALSA_PCM_PLUGINS="adpcm alaw asym copy dmix dshare dsnoop empty extplug file hooks iec958 ioplug ladspa lfloat linear meter mulaw multi null plug rate route share shm softvol" APACHE2_MODULES="actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" ELIBC="glibc" INPUT_DEVICES="mouse keyboard joystick evdev" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LINGUAS="en en_GB" USERLAND="GNU" VIDEO_CARDS="nvidia v4l nv"
Unset:  CPPFLAGS, CTARGET, EMERGE_DEFAULT_OPTS, INSTALL_MASK, LANG, LC_ALL, LDFLAGS, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS, PORTDIR_OVERLAY
Comment 13 Carsten Lohrke (RETIRED) gentoo-dev 2008-07-16 07:01:16 UTC
*** Bug 231928 has been marked as a duplicate of this bug. ***
Comment 14 Carsten Lohrke (RETIRED) gentoo-dev 2008-09-14 00:30:52 UTC
*** Bug 222207 has been marked as a duplicate of this bug. ***
Comment 15 Timo Gurr (RETIRED) gentoo-dev 2009-01-19 15:55:00 UTC
*** Bug 253519 has been marked as a duplicate of this bug. ***
Comment 16 Zac Medico gentoo-dev 2009-03-09 19:07:58 UTC
*** Bug 261744 has been marked as a duplicate of this bug. ***
Comment 17 Jorge Manuel B. S. Vicetto Gentoo Infrastructure gentoo-dev 2009-04-11 01:38:39 UTC
Getting KDE out of this bug as it should be mostly fixed by now.
Comment 18 Vítor Brandão (noisebleed) 2009-09-14 11:24:13 UTC
Fell into this bug while installing kdebase-meta (fresh AMD64 install).

Using 'emerge -1 kdnssd-avahi && emerge kdebase-meta' as a workaround overcomes this problem.

Is this bug still listed for resolution?

	
Packages in use (or to be merged):
kde-base/kdebase-meta-3.5.10
kde-misc/kdnssd-avahi-0.1.2-r1
sys-apps/portage-2.1.6.13
Comment 19 Zac Medico gentoo-dev 2009-09-14 11:51:15 UTC
(In reply to comment #18)
> Fell into this bug while installing kdebase-meta (fresh AMD64 install).
> 
> Using 'emerge -1 kdnssd-avahi && emerge kdebase-meta' as a workaround overcomes
> this problem.
> 
> Is this bug still listed for resolution?

Yes, we'll get it fixed eventually. However, it seems like the existing code that's in portage-2.1.6.13 should have handled this case correctly. I'll have to try and reproduce this to see if I can understand why it wasn't handled in your case. If you are able to reproduce the incorrect merge order calculation, then please attach emerge --pretend --debug output.
Comment 20 Zac Medico gentoo-dev 2009-11-05 08:30:59 UTC
*** Bug 290721 has been marked as a duplicate of this bug. ***
Comment 21 Rémi Cardona gentoo-dev 2009-11-05 08:33:14 UTC
*** Bug 291366 has been marked as a duplicate of this bug. ***
Comment 22 Rémi Cardona gentoo-dev 2009-11-14 15:50:53 UTC
*** Bug 293112 has been marked as a duplicate of this bug. ***
Comment 23 Zac Medico gentoo-dev 2010-07-12 12:05:24 UTC
*** Bug 327623 has been marked as a duplicate of this bug. ***
Comment 24 Zac Medico gentoo-dev 2018-01-28 14:10:49 UTC
*** Bug 645958 has been marked as a duplicate of this bug. ***
Comment 25 Larry the Git Cow gentoo-dev 2019-12-26 23:00:09 UTC
The bug has been referenced in the following commit(s):

https://gitweb.gentoo.org/proj/portage.git/commit/?id=680276cc4d4faa653203366cbe3c896ac3883cf2

commit 680276cc4d4faa653203366cbe3c896ac3883cf2
Author:     Zac Medico <zmedico@gentoo.org>
AuthorDate: 2019-12-25 08:37:18 +0000
Commit:     Zac Medico <zmedico@gentoo.org>
CommitDate: 2019-12-26 22:56:39 +0000

    _serialize_tasks: limit scope of dropped circular dependencies
    
    Ensure that all members of a buildtime dependency cycle are merged
    as a group, such that packages which depend on one or more members
    of the group will only be merged *after* the entire group has been
    merged.
    
    This extends runtime cycle handling to also handle buildtime cycles
    in cases where the buildtime dependencies happen to be satisfied by
    installed packages. In situations when this is necessary, it is
    desirable to rely on the old installed instances of these packages
    as little as possible, since they might have been broken by the
    upgrade of a package that is a member of the dependency cycle.
    Upgrading members of the cycle as a group effectively minimizes
    reliance on the old installed package instances, avoiding some cases
    of bug 199856. For example, it should avoid bug 703676, where
    libspectre reportedly failed to build against an old installed
    instance of ghostscript-gpl.
    
    Bug: https://bugs.gentoo.org/199856
    Bug: https://bugs.gentoo.org/689644
    Bug: https://bugs.gentoo.org/690436
    Bug: https://bugs.gentoo.org/703676
    Signed-off-by: Zac Medico <zmedico@gentoo.org>

 lib/_emerge/depgraph.py                        | 94 +++++++++++++++-----------
 lib/portage/tests/resolver/test_merge_order.py | 25 ++++++-
 2 files changed, 78 insertions(+), 41 deletions(-)
Comment 26 Larry the Git Cow gentoo-dev 2019-12-26 23:01:45 UTC
The bug has been referenced in the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=1793a98a4543c8ea3b166af4383744ab060f37d5

commit 1793a98a4543c8ea3b166af4383744ab060f37d5
Author:     Zac Medico <zmedico@gentoo.org>
AuthorDate: 2019-12-26 22:46:29 +0000
Commit:     Zac Medico <zmedico@gentoo.org>
CommitDate: 2019-12-26 22:49:36 +0000

    sys-apps/portage: Bump to version 2.3.84
    
     #690436 limit scope of dropped circular dependencies, which should
             solve some cases of bug 199856 such as bug 703676 (also see
             tracker bug 689644)
    
    Bug: https://bugs.gentoo.org/701268
    Bug: https://bugs.gentoo.org/199856
    Bug: https://bugs.gentoo.org/689644
    Bug: https://bugs.gentoo.org/690436
    Bug: https://bugs.gentoo.org/703676
    Package-Manager: Portage-2.3.84, Repoman-2.3.20
    Signed-off-by: Zac Medico <zmedico@gentoo.org>

 sys-apps/portage/Manifest              |   1 +
 sys-apps/portage/portage-2.3.84.ebuild | 276 +++++++++++++++++++++++++++++++++
 2 files changed, 277 insertions(+)